<?php 

// Copied from Contact Form 7

add_action('rest_api_init', 'wgpayl_rest_api_init', 10, 0 );

function wgpayl_rest_api_init() {
	$namespace = 'giveasyoulive/v1';

	register_rest_route($namespace, '/search', 
		array(
			'methods' => WP_REST_Server::READABLE,
			'callback' => 'wpgayl_rest_get_items',
			'permission_callback' => function() {
				if ( current_user_can('edit_posts') ) {
					return true;
				} 
				else {
					return new WP_Error( 'wpgayl_forbidden',
						__( "You are not allowed to access this", 'give-as-you-live' ),
						array( 'status' => 403 )
					);
				}
			},
		)
	);
}

function wpgayl_rest_get_items(WP_REST_Request $request) {
	$args = array('post_type' => 'wpplugin_gayl_button');

	$per_page = $request->get_param( 'per_page' );

	if ( null !== $per_page ) {
		$args['posts_per_page'] = (int) $per_page;
	}

	$offset = $request->get_param( 'offset' );

	if ( null !== $offset ) {
		$args['offset'] = (int) $offset;
	}

	$order = $request->get_param( 'order' );

	if ( null !== $order ) {
		$args['order'] = (string) $order;
	}

	$orderby = $request->get_param( 'orderby' );

	if ( null !== $orderby ) {
		$args['orderby'] = (string) $orderby;
	}

	$search = $request->get_param( 'search' );

	if ( null !== $search ) {
		$args['s'] = (string) $search;
	}

	$items = get_posts($args);

	foreach ( $items as $item ) {
		$response[] = array(
			'id' => $item->ID,
			'slug' => $item->post_name,
			'title' => html_entity_decode($item->post_title), // not sure why html_entity_decode() is needed, but the &pound; weren't displaying as £s
		);
	}

	return rest_ensure_response($response);
}
