<?php

add_action('init', 'wpgayl_init_block_editor_assets', 10, 0);

function wpgayl_init_block_editor_assets() {
	$assets = array();

	$asset_file = plugins_url('/js/block/index.asset.php', __FILE__);

	if ( file_exists( $asset_file ) ) {
		$assets = include( $asset_file );
	}

	$assets = wp_parse_args( $assets, array(
		'src' => plugins_url('/js/block/index.js', __FILE__),
		'dependencies' => array(
			'wp-api-fetch',
			'wp-components',
			'wp-compose',
			'wp-blocks',
			'wp-element',
			'wp-i18n',
		),
		'version' => WPGAYL_VERSION,
	) );

	wp_register_script('giveasyoulive-block-editor', $assets['src'], $assets['dependencies'], $assets['version']);

	register_block_type(
		'give-as-you-live/widget', [
			'editor_script' => 'giveasyoulive-block-editor',
			'render_callback' => 'wpgayl_block_render_callback',
			'attributes'      => [
				'id' => ['default' => null, 'type' => 'integer'],
			]
		]
	);

	wp_enqueue_style('giveasyoulive_public');
}

function wpgayl_block_render_callback($object) {
	return do_shortcode("[giveasyoulive id=\"${object['id']}\"]");
}
