<?php

function wpgayl_plugin_buttons() {
	// Load create page
	if (isset($_GET['action']) && $_GET['action'] == "new") {
		include_once ('buttons_new.php');
	}
	
	// Load edit page
	if (isset($_GET['action']) && $_GET['action'] == "edit") {
		$post_id = $_GET['product'];
		check_admin_referer('edit_'.$post_id);
		include_once ('buttons_edit.php');
	}

	// Delete function
	if (isset($_GET['action']) && $_GET['action'] == "delete" || isset($_GET['action2']) && $_GET['action2'] == "delete") {		
		include_once ('buttons_delete.php');
	}

	if (!isset($_GET['action']) || $_GET['action'] == -1) {
		// Use Wordpress' table function
		if(!class_exists('WP_List_Table')) {
			require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
		}

		class wpgayl_buttons_table extends WP_List_Table {
			function get_data() {
				global $wp_query;

				$args = array('post_type' => 'wpplugin_gayl_button','posts_per_page' => -1);
				$posts = get_posts($args);
				$count = "0";

				foreach ($posts as $post) {

					$post_id = $posts[$count]->ID ?? null;
					$post_title = $posts[$count]->post_title ?? '';

					if ($post_title == "" || $post_title == " " || empty($post_title)) {
						$post_title = "(No Name)";
					}

					$shortcode = '<input type="text" value="[giveasyoulive id='.$post_id.']">';

					$meta = unserialize(get_post_meta($post_id,'wpgayl_data', true));

					$data[] = array(
						'ID' 		=> $post_id,
						'product' 	=> $post_title,
						'charity' 	=> esc_attr($meta['charity_name'] ?? null),
						'shortcode' => $shortcode,
					);

					$count++;
				}
				
				if (empty($data)) {
					$data = array();
				}
				
				return $data;
			}

			function __construct() {
				global $status, $page;
				
				parent::__construct( array(
					'singular'  => 'product',
					'plural'    => 'products',
					'ajax'      => false
				) );
			}

			function column_default($item, $column_name){
					switch($column_name){
						case 'product':
						case 'charity':
						case 'shortcode':
							return $item[$column_name];
						default:
							return print_r($item,true);
					}
			}

			function column_product($item){
				// edit
				$edit_bare = '?page=wpgayl_buttons&action=edit&product='.$item['ID'];
				$edit_url = wp_nonce_url($edit_bare, 'edit_'.$item['ID']);
				
				// delete
				$delete_bare = '?page=wpgayl_buttons&action=delete&inline=true&product='.$item['ID'];
				$delete_url = wp_nonce_url($delete_bare, 'bulk-'.$this->_args['plural']);
				
				$actions = array(
					'edit'   => "<a href=$edit_url>Edit</a>",
					'delete' => "<a href=$delete_url>Delete</a>"
				);

				return sprintf('%1$s %2$s', $item['product'], $this->row_actions($actions));
			}

			function column_cb($item) {
				return sprintf('<input type="checkbox" name="%1$s[]" value="%2$s" />', $this->_args['singular'], $item['ID']);
			}

			function get_columns() {
				$columns = array(
					'cb'        => '<input type="checkbox" />',
					'product'   => 'Name',
					'charity'   => 'Charity',
					'shortcode' => 'Shortcode',
				);
				return $columns;
			}

			function no_items() {
				_e( 'No buttons or forms found.' );
			}

			function get_bulk_actions() {
					$actions = array(
						'delete' => 'Delete'
					);
					return $actions;
			}
			
			public function process_bulk_action() {
				if (isset($_GET['_wpnonce']) && !empty($_GET['_wpnonce'])) {
					$nonce  = $_GET['_wpnonce'];
					$action = 'bulk-' . $this->_args['plural'];
					
					if (!wp_verify_nonce($nonce, $action)) {
						wp_die('Security check fail'); 
					}
				}
			}

			function prepare_items() {
				global $wpdb;

				$per_page = 20;

				$columns = $this->get_columns();
				$hidden = array();
				$sortable = $this->get_sortable_columns();

				$this->_column_headers = array($columns, $hidden, $sortable);

				$this->process_bulk_action();

				$data = $this->get_data();

				$current_page = $this->get_pagenum();

				$total_items = count($data);

				$data = array_slice($data, (($current_page - 1) * $per_page), $per_page);

				$this->items = $data;

				$this->set_pagination_args( array(
					'total_items' => $total_items,
					'per_page'    => $per_page,
					'total_pages' => ceil($total_items/$per_page)
				) );
			}
		}

		function wpgayl_tt_render_list_page() {
			$table = new wpgayl_buttons_table();
			$table->prepare_items();

			?>

			<div class="wrap">
				<h1 class="wp-heading-inline">Give as you Live Buttons, Forms &amp; Pages</h1>
				<a href="?page=wpgayl_buttons&action=new" class="page-title-action">Create New</a>
			
				<div style="width:98%">
					<?php
						if (isset($_GET['message']) && $_GET['message'] == "created") {
							echo "<div class='updated'><p>Give as you Live widget created.</p></div>";
						}
						if (isset($_GET['message']) && $_GET['message'] == "updated") {
							echo "<div class='updated'><p>Give as you Live widget updated.</p></div>";
						}
						if (isset($_GET['message']) && $_GET['message'] == "deleted") {
							echo "<div class='updated'><p>Give as you Live widget(s) deleted.</p></div>";
						}
						if (isset($_GET['message']) && $_GET['message'] == "nothing") {
							echo "<div class='updated'><p>No action selected.</p></div>";
						}
						if (isset($_GET['message']) && $_GET['message'] == "nothing_deleted") {
							echo "<div class='updated'><p>Nothing selected to delete.</p></div>";
						}
						if (isset($_GET['message']) && $_GET['message'] == "error") {
							echo "<div class='updated'><p>An error occured while processing the query. Please try again.</p></div>";
						}
					?>

					<form id="products-filter" method="get">
						<input type="hidden" name="page" value="<?php echo esc_attr($_REQUEST['page'] ?? null) ?>" />
						<?php $table->display() ?>
					</form>
				</div>

				<?php if (count($table->items) == 0) { ?>
					<div id="postbox-container-1" class="postbox-container gayl-admin-examples gayl-admin-examples--horizontal">
						<h3 class="wp-heading-inline">Examples</h3>

						<figure>
							<figcaption>Custom button example</figcaption>
							<img src="https://ps.w.org/give-as-you-live/assets/screenshot-6.png" alt="Custom button example" />
						</figure>
						
						<figure>
							<figcaption>Image button example</figcaption>
							<img src="https://admin.giveasyoulive.com/images/toolkit/donations/button-rect-donate-navy.png" alt="Image button example" />
						</figure>
						
						<figure>
							<figcaption>Form example</figcaption>
							<img src="https://ps.w.org/give-as-you-live/assets/screenshot-7.png" alt="Form example" />
						</figure>
						
						<figure>
							<figcaption>Page example</figcaption>
							<img src="https://ps.w.org/give-as-you-live/assets/screenshot-8.png" alt="Page example" />
						</figure>
					</div>
				</div>
			<?php } ?>

			<?php
		}

		wpgayl_tt_render_list_page();		
	}
}