<?php

	$post_data = get_post($post_id);
	$post_title = $post_data->post_title;

	// Some more shared functions
	include_once ('buttons_meta.php');
	include_once ('attributes.php');

	// Deal with the postback requests
	if (isset($_POST['update'])) {		
		if (!$post_id) {
			wp_safe_redirect(menu_page_url('wpgayl_buttons', false));
			exit;
		}

		// Validate
		$wpgayl_validation = wpgayl_validate($_POST);
		$_POST = array_merge($_POST, $wpgayl_validation["data"]);

		// If valid, continue
		if($wpgayl_validation['valid'] === true) {
			$wpgayl_post_meta = wpgayl_set_all_meta();
			$wpgayl_post_name = wpgayl_set_post_name();

			$wpgayl_post = array(
				'ID'         => $post_id,
				'post_title' => sanitize_text_field($wpgayl_post_name),
			);

			wp_update_post($wpgayl_post);

			// Serializing means it's all in one database row, plus it states the object types
			update_post_meta($post_id, 'wpgayl_data', sanitize_text_field(serialize($wpgayl_post_meta)));

			// Update defaults
			if(intval($_POST['wpgayl_update_defaults'])) {

				if($_POST['wpgayl_type'] == "page") {
					$wpgayl_settings_int = ["charity_id"];
					$wpgayl_settings_text = ["charity_name", "charity_uri"];
				}
				else {
					$wpgayl_settings_int = ["charity_id", "button_radius", "form_border_width"];
					$wpgayl_settings_text = ["charity_name", "charity_uri", "button_bg_colour", "button_bg_colour", "button_text_colour", "button_size", "button_text", "button_icon", "form_bg_colour", "form_text_colour", "form_border_colour", "form_border_width"];
				}

				$wpgayl_settings = wpgayl_set_settings("int",  $wpgayl_settings_int);
				$wpgayl_settings = wpgayl_set_settings("text", $wpgayl_settings_text);

				update_option("wpgayl_settingsoptions", $wpgayl_settings);
			}
			
			wp_safe_redirect(add_query_arg(['message' => 'updated'], menu_page_url('wpgayl_buttons', false)));
			exit;
		}
	}

	// The form - shared by new and edit
	include_once ('buttons_form.php');
?>