<?php

	global $current_user;

	// Some more shared functions
	include_once ('buttons_meta.php');
	include_once ('attributes.php');

	// Deal with the postback requests
	if (isset($_POST['update'])) {

		// Validate
		$wpgayl_validation = wpgayl_validate($_POST);
		$_POST = array_merge($_POST, $wpgayl_validation["data"]);

		// If valid, continue
		if($wpgayl_validation['valid'] === true) {
			$wpgayl_post_meta = wpgayl_set_all_meta();
			$wpgayl_post_name = wpgayl_set_post_name();

			$wpgayl_post = array(
				'post_title'  => sanitize_text_field($wpgayl_post_name),
				'post_status' => 'publish',
				'post_author' => $current_user->ID,
				'post_type'   => 'wpplugin_gayl_button'
			);

			// Save the post to the database
			$post_id = wp_insert_post($wpgayl_post);

			// Serializing means it's all in one database row, plus it states the object types
			update_post_meta($post_id, 'wpgayl_data', sanitize_text_field(serialize($wpgayl_post_meta)));

			// Update defaults
			if(intval($_POST['wpgayl_update_defaults'])) {
				if($_POST['wpgayl_type'] == "page") {
					$wpgayl_settings_int = ["charity_id"];
					$wpgayl_settings_text = ["charity_name", "charity_uri"];
				}
				else {
					$wpgayl_settings_int = ["charity_id", "button_radius", "form_border_width"];
					$wpgayl_settings_text = ["charity_name", "charity_uri", "button_bg_colour", "button_bg_colour", "button_text_colour", "button_size", "button_text", "button_icon", "form_bg_colour", "form_text_colour", "form_border_colour", "form_border_width"];
				}

				$wpgayl_settings = wpgayl_set_settings("int",  $wpgayl_settings_int);
				$wpgayl_settings = wpgayl_set_settings("text", $wpgayl_settings_text);

				update_option("wpgayl_settingsoptions", $wpgayl_settings);
			}

			// Ping GAYL server so we know they've added it (no personal details passed, no ad tracking, the log is visible to the charity in their account)
			try {
				// Which asset?
				if(isset($_POST['wpgayl_type'])){
					if($_POST['wpgayl_type'] == "button") {
						$asset_id = 1411;
					}
					else if($_POST['wpgayl_type'] == "form") {
						$asset_id = 1412;
					}
					else if($_POST['wpgayl_type'] == "page") {
						$asset_id = 1413;
					}
				}

				$response = wp_remote_post('https://admin.giveasyoulive.com/toolkit/track?cid=' . $_POST['wpgayl_charity_id'], [
					"body" => [
						"charity_id" => $_POST['wpgayl_charity_id'],
						"product"    => (isset($_POST['wpgayl_page_type']) && $_POST['wpgayl_page_type'] == "gaylo_charity" ? "online" : "donate"),
						"campaignId" => 196,
						"assetId"    => $asset_id ?? null,
					]
				]);
			}
			catch (Exception $e) { 
				/* Do nothing as there's a return below */ 
			}

			wp_safe_redirect(add_query_arg(['message' => 'created'], menu_page_url('wpgayl_buttons', false)));
			exit;
		}
	}

	// The form - shared by new and edit
	include_once ('buttons_form.php');
?>