<?php

// Confirmation message shown once plugin has been installed and activated
// todo: change to 'create first button'
add_action('admin_notices', 'wpgayl_admin_notices');
function wpgayl_admin_notices() {
	if (!get_option('wpgayl_notice_shown')) {
		echo "<div class='updated'><p><a href='admin.php?page=wpgayl_settings'>Give as you Live has been activated - click here to view the plugin settings</a>.</p></div>";
		update_option("wpgayl_notice_shown", "true");
	}
}

// Add menu item
add_action("admin_menu", "wpgayl_plugin_menu");
function wpgayl_plugin_menu() {
	global $plugin_dir_url;

	$svg = 'data:image/svg+xml;base64,' . base64_encode('<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 16 16"><path d="M11.4 1.5C9.5 1.3 7.8 2.7 7.2 5c-2.2-1-4.5-.7-5.6.8-1.3 1.8-.4 4.7 2.1 6.4 3.3 2.2 8 2.3 8 2.3s2.9-3.6 3.3-7.4c.2-2.9-1.4-5.5-3.6-5.6z" fill="#FFF"/></svg>');
	
	add_menu_page("Give as you Live", "Give as you Live", "manage_options", "wpgayl_buttons", "wpgayl_plugin_buttons", $svg, '28.5');
	
	add_submenu_page("wpgayl_buttons", "Give as you Live Buttons, Forms &amp; Pages", "Buttons, Forms &amp; Pages", "manage_options", "wpgayl_buttons", "wpgayl_plugin_buttons");
	
	add_submenu_page("wpgayl_buttons", "Give as you Live Settings", "Settings", "manage_options", "wpgayl_settings", "wpgayl_plugin_options");
}

function wpgayl_action_links($links) {

global $support_link, $edit_link, $settings_link;
   $links[] = '<a href="admin.php?page=wpgayl_settings">Settings</a>';
   return $links;
}

add_filter( 'plugin_action_links_' . $plugin_basename, 'wpgayl_action_links' );
