<?php

// Register shortcode
add_shortcode('giveasyoulive', 'wpgayl_shortcode');

function wpgayl_shortcode($atts) {

	// Add CSS and JS
	wp_enqueue_style('giveasyoulive_public');
	wp_enqueue_script('giveasyoulive_public');

	// get shortcode id
	$atts = shortcode_atts(array(
		'id'     => '',
		'align'  => '',
		'widget' => '',
		'name'   => ''
	), $atts);
		
	$post_id = $atts['id'];

	// Used for IDs to ensure uniqueness (even if same shortcode used multiple times on page)
	$wpgayl_random_id = rand();

	// Get the post meta
	$meta = unserialize(get_post_meta($post_id,'wpgayl_data', true));

	// Split out the post meta
	$wpgayl_id                     = $meta['id'] ?? null;
	$wpgayl_type                   = $meta['type'] ?? null;
	$wpgayl_charity_id             = $meta['charity_id'] ?? null;
	$wpgayl_charity_name           = $meta['charity_name'] ?? null;
	$wpgayl_charity_uri            = $meta['charity_uri'] ?? null;
	$wpgayl_button_bg_colour       = $meta['button_bg_colour'] ?? null;
	$wpgayl_button_radius          = $meta['button_radius'] ?? null;
	$wpgayl_button_text_colour     = $meta['button_text_colour'] ?? null;
	$wpgayl_button_size            = $meta['button_size'] ?? null;
	$wpgayl_button_text            = $meta['button_text'] ?? null;
	$wpgayl_button_icon            = $meta['button_icon'] ?? null;
	$wpgayl_button_image_url       = $meta['button_image_url'] ?? null;
	$wpgayl_button_amount          = $meta['button_amount'] ?? null;
	$wpgayl_button_repeat          = $meta['button_repeat'] ?? null;
	$wpgayl_form_mode              = $meta['form_mode'] ?? null;
	$wpgayl_form_bg_colour         = $meta['form_bg_colour'] ?? null;
	$wpgayl_form_text_colour       = $meta['form_text_colour'] ?? null;
	$wpgayl_form_border_colour     = $meta['form_border_colour'] ?? null;
	$wpgayl_form_border_width      = $meta['form_border_width'] ?? null;
	$wpgayl_form_title             = $meta['form_title'] ?? null;
	$wpgayl_form_description       = $meta['form_description'] ?? null;
	$wpgayl_form_amount_a          = $meta['form_amount_a'] ?? null;
	$wpgayl_form_amount_b          = $meta['form_amount_b'] ?? null;
	$wpgayl_form_amount_c          = $meta['form_amount_c'] ?? null;
	$wpgayl_form_amount_d          = $meta['form_amount_d'] ?? null;
	$wpgayl_form_amount_e          = $meta['form_amount_e'] ?? null;
	$wpgayl_form_amount_f          = $meta['form_amount_f'] ?? null;
	$wpgayl_form_amount_g          = $meta['form_amount_g'] ?? null;
	$wpgayl_form_amount_h          = $meta['form_amount_h'] ?? null;
	$wpgayl_form_amount_custom     = $meta['form_amount_custom'] ?? null;
	$wpgayl_form_show_gayl_message = $meta['form_show_gayl_message'] ?? null;
	$wpgayl_page_type              = $meta['page_type'] ?? null;
	
	// Widget ???????
	if ($atts['widget'] == "true") {
		$width = "180px";
	} else {
		$width = "220px";
	}
	
	// Alignment - from Wordpress widget settings???
	if ($atts['align'] == "left") { $alignment = "style='float: left;'"; }
	if ($atts['align'] == "right") { $alignment = "style='float: right;'"; }
	if ($atts['align'] == "center") { $alignment = "style='margin-left: auto;margin-right: auto;width:$width'"; }
	if (empty($atts['align'])) { $alignment = ""; }

	// These are used for UTM params and hidden form inputs
	$custom_params = [];

	// 
	// Setup
	// 

	// List the variables that are set in the below IF statements - can cause issues in PHP v8 if not done
	$button_classes = "";
	$button_css_variables = "";
	$form_classes   = "";
	$form_css_variables = "";
	$form_hidden_inputs = "";
	$icon_end   = "";
	$icon_start = "";
	$link = "";

	// Button and form shared values
	if($wpgayl_type == "button" || $wpgayl_type == "form") {
		$link = "https://donate.giveasyoulive.com/donate"; // CID added later

		// Colours - set the CSS variables
		if(isset($wpgayl_button_bg_colour)) {
			$button_css_variables .= "--gayl-button-bg-colour:" . $wpgayl_button_bg_colour . ";";
		}
		if(isset($wpgayl_button_radius)) {
			$button_css_variables .= "--gayl-button-radius:" . $wpgayl_button_radius . "px;";
		}
		if(isset($wpgayl_button_text_colour)) {
			$button_css_variables .= "--gayl-button-text-colour:" . $wpgayl_button_text_colour . ";";
		}

		// Sizing - set the classes
		if($wpgayl_button_size == "l") {
			$button_classes = "gayl-button--l";
			$form_classes   = "gayl-form--l";
		}
		else if($wpgayl_button_size == "s") {
			$button_classes = "gayl-button--s";
			$form_classes   = "gayl-form--s";
		}

		// Set up the icon
		if(isset($wpgayl_button_icon)) {
			if($wpgayl_button_icon == "arrow") {
				$icon_end = ' ' . wpgayl_create_arrow_icon();
			}
			else if($wpgayl_button_icon == "chevron") {
				$icon_end = ' ' . wpgayl_create_chevron_icon();
			}
			else if($wpgayl_button_icon == "gayl") {
				$icon_start = wpgayl_create_gayl_icon() . ' ';
			}
			else if($wpgayl_button_icon == "heart") {
				$icon_start = wpgayl_create_heart_icon() . ' ';	
			}
		}		
	}

	// Button specific values
	if($wpgayl_type == "button") {
		if(isset($wpgayl_button_amount)) {
			$custom_params['amount'] = $wpgayl_button_amount;
		}

		if(isset($wpgayl_button_repeat)) {
			$custom_params['rp'] = 1;
		}
	}

	// Form specific values
	if($wpgayl_type == "form") {
		// Colours - set the CSS variables
		if(isset($wpgayl_form_bg_colour)) {
			$form_css_variables .= "--gayl-form-bg-colour:" . $wpgayl_form_bg_colour . ";";
		}
		if(isset($wpgayl_form_text_colour)) {
			$form_css_variables .= "--gayl-form-text-colour:" . $wpgayl_form_text_colour . ";";
		}
		if(isset($wpgayl_form_border_colour)) {
			$form_css_variables .= "--gayl-form-border-colour:" . $wpgayl_form_border_colour . ";";
		}
		if(isset($wpgayl_form_border_width)) {
			$form_css_variables .= "--gayl-form-border-width:" . $wpgayl_form_border_width . ";";
		}

		// Does the form have a dark background?
		if(wpgayl_hex_to_yiq($wpgayl_form_bg_colour) <= 180) {
			$form_classes .= "gayl-form--dark";
		}

		// Pre-set repeat donation
		if(isset($wpgayl_form_mode) && $wpgayl_form_mode == 'repeat') {
			$custom_params['rp'] = 1;
		}

		// How many amounts do we have? Used to set the max-width
		$wpgayl_form_amounts = [$wpgayl_form_amount_a, $wpgayl_form_amount_b, $wpgayl_form_amount_c, $wpgayl_form_amount_d, $wpgayl_form_amount_e, $wpgayl_form_amount_f, $wpgayl_form_amount_g, $wpgayl_form_amount_h];
		$wpgayl_form_amounts = array_filter($wpgayl_form_amounts, function($amount) { return !empty($amount); });
		$form_css_variables .= "--gayl-form-max-width:" . ((180 - (10 * count($wpgayl_form_amounts))) * count($wpgayl_form_amounts)) . "px;";
	}

	// Page specific values
	if($wpgayl_type == "page") {
		if($wpgayl_page_type == "gaylo_charity"){
			$link = "https://www.giveasyoulive.com/join/" . $wpgayl_charity_uri . "/_iframe";
		}
		else if($wpgayl_page_type == "gayld_charity"){
			$link = "https://donate.giveasyoulive.com/charity/" . $wpgayl_charity_uri;
		}
		else if($wpgayl_page_type == "gayld_donate"){
			$link = "https://donate.giveasyoulive.com/donate"; // CID added later
		}
	}

	if(isset($wpgayl_form_amount_a)) {
		$custom_params['amounts'] = $wpgayl_form_amount_a;
		$custom_params['amounts'] = $custom_params['amounts'] . (isset($wpgayl_form_amount_b) ? '|' . $wpgayl_form_amount_b : '');
		$custom_params['amounts'] = $custom_params['amounts'] . (isset($wpgayl_form_amount_c) ? '|' . $wpgayl_form_amount_c : '');
		$custom_params['amounts'] = $custom_params['amounts'] . (isset($wpgayl_form_amount_d) ? '|' . $wpgayl_form_amount_d : '');
		$custom_params['amounts'] = $custom_params['amounts'] . (isset($wpgayl_form_amount_e) ? '|' . $wpgayl_form_amount_e : '');
		$custom_params['amounts'] = $custom_params['amounts'] . (isset($wpgayl_form_amount_f) ? '|' . $wpgayl_form_amount_f : '');
		$custom_params['amounts'] = $custom_params['amounts'] . (isset($wpgayl_form_amount_g) ? '|' . $wpgayl_form_amount_g : '');
		$custom_params['amounts'] = $custom_params['amounts'] . (isset($wpgayl_form_amount_h) ? '|' . $wpgayl_form_amount_h : '');
	}

	//
	// Process the custom params
	//

	$button_css_variables_html = "style=\"${button_css_variables}\"";
	$form_css_variables_html   = "style=\"${form_css_variables}\"";
	$all_css_variables_html    = "style=\"${button_css_variables} ${form_css_variables}\"";

	$custom_params += [
		'cid'          => $wpgayl_charity_id,
		'wl'           => 1,
		'bc'           => str_replace('#', '', $wpgayl_button_bg_colour),
		'tc'           => str_replace('#', '', $wpgayl_button_text_colour),
		'br'           => $wpgayl_button_radius,
		'utm_source'   => 'charitytoolkit',
		'utm_content'  => $wpgayl_charity_id,
		'utm_medium'   => 'charitywordpress' . $wpgayl_type,
		'utm_campaign' => 'CTWordpress' . ucfirst($wpgayl_type),
	];

	// Create the URL
	$link = wp_add_gayl_url_param($link, $custom_params);

	// Create the hidden form inputs
	foreach($custom_params as $param => $value) {
		$form_hidden_inputs .= "<input type=\"hidden\" name=\"" . htmlentities($param) . "\" value=\"" . htmlentities($value) . "\" />";
	}

	//
	// Now for displaying the content
	//

	$output = "<div $alignment>";

	// Button
	if($wpgayl_type == "button") {
		if(!isset($wpgayl_button_image_url) || empty($wpgayl_button_image_url)) {
			$output .= "<a class=\"gayl-button ${button_classes}\" target=\"_blank\" href=\"${link}\" ${button_css_variables_html}>";
			$output .= $icon_start . $wpgayl_button_text . $icon_end;
		}
		else {
			$output .= "<a target=\"_blank\" href=\"${link}\">";
			$output .= "<img src=\"https://admin.giveasyoulive.com/images/toolkit/donations/${wpgayl_button_image_url}.png\" alt=\"Donate to us\" class=\"gayl-button-image\" />";
		}

		$output .= "</a>";
	}
	else if($wpgayl_type == "form") {
		$output .= "<section class=\"gayl-form-container\"><form class=\"gayl-form ${form_classes}\" target=\"_blank\" action=\"${link}\" method=\"GET\" ${all_css_variables_html}>";

		$output .= $form_hidden_inputs;

		if(isset($wpgayl_form_title)) {
			$output .= "<h2>${wpgayl_form_title}</h2>";
		}

		if(isset($wpgayl_form_description)) {
			$output .= "<p>${wpgayl_form_description}</p>";
		}

		if($wpgayl_form_mode == 'both') {
			$output .= "<div class=\"gayl-form-mode\">";
			$output .= 		"<div class=\"gayl-button js-gayl-mode-toggle-container\">";
			$output .= 			"<div class=\"gayl-button-toggle\">";
			$output .=				 "<input class=\"js-gayl-mode-toggle\" type=\"radio\" id=\"rp-n-${wpgayl_random_id}\" name=\"rp\" value=\"0\" checked />";
			$output .= 					"<label for=\"rp-n-${wpgayl_random_id}\"><span>Single donation</span></label>";
			$output .= 			"</div>";
			$output .= 		"</div>";
			$output .= 		"<div class=\"gayl-button gayl-button-outline js-gayl-mode-toggle-container\">";
			$output .= 			"<div class=\"gayl-button-toggle\">";
			$output .= 				"<input class=\"js-gayl-mode-toggle\" type=\"radio\" id=\"rp-y-${wpgayl_random_id}\" name=\"rp\" value=\"1\" />";
			$output .= 				"<label for=\"rp-y-${wpgayl_random_id}\"><span>Monthly donation</span></label>";
			$output .= 			"</div>";
			$output .= 		"</div>";
			$output .= "</div>";
		}
		
		if(isset($wpgayl_form_amount_a)) {
			$output .= "<div class=\"gayl-form-amounts\">";
			$output .= wpgayl_display_form_amount($wpgayl_form_amount_a);
			$output .= wpgayl_display_form_amount($wpgayl_form_amount_b);
			$output .= wpgayl_display_form_amount($wpgayl_form_amount_c);
			$output .= wpgayl_display_form_amount($wpgayl_form_amount_d);
			$output .= wpgayl_display_form_amount($wpgayl_form_amount_e);
			$output .= wpgayl_display_form_amount($wpgayl_form_amount_f);
			$output .= wpgayl_display_form_amount($wpgayl_form_amount_g);
			$output .= wpgayl_display_form_amount($wpgayl_form_amount_h);
			$output .= "</div>";
		}

		if($wpgayl_form_amount_custom == true) {
			$output .= "<div class=\"gayl-form-custom\">";
			$output .= "<div><span>&pound;</span></div>";
			$output .= "<input type=\"number\" inputmode=\"decimal\" min=\"5\" step=\"0.01\" name=\"amount\" class=\"gayl-form-custom-input js-gayl-custom\" />";
			$output .= "</div>";
		}
		else {
			$output .= "<input type=\"hidden\" name=\"amount\" class=\"gayl-form-custom-input\" />";
		}

		$output .= "<button type=\"submit\" class=\"gayl-button ${button_classes}\">${icon_start}${wpgayl_button_text}${icon_end}</button>";

		if($wpgayl_form_show_gayl_message == true) {
			$wp_logo_variant = wpgayl_hex_to_yiq($wpgayl_form_bg_colour) > 180 ? "lc" : "lw";

			$output .= "<div class=\"gayl-form-powered\"><b>Powered by</b><a href=\"https://donate.giveasyoulive.com/\" target=\"_blank\" rel=\"nofollow noopener\"><img src=\"https://donate.giveasyoulive.com/images/common/logos/gayl/2023/${wp_logo_variant}/donate.svg\" alt=\"Give as you Live Donate\" width=\"560\" height=\"140\" /></a></div>";
		}

		$output .= "</form></section>";
	}
	else if($wpgayl_type == "page") {
		$output .= "<iframe class=\"gayl-iframe\" src=\"${link}\" scrolling=\"yes\" frameborder=\"0\" width=\"100%\" height=\"1200\" sandbox=\"allow-forms allow-same-origin allow-scripts allow-top-navigation allow-popups\"></iframe>";		
	}

	$output .= "</div>";
	return $output;
}